//библиотека WiFi
#include <GyverButton.h>
#include <WiFi.h>
#include <HTTPClient.h>
//название сети и пороль
const char* ssid = "RoboSphera_esp32";
const char* password = "18273645";
//ссылка на получение информации о режиме
const char* serverNameStatus = "http://192.168.4.1/rezim";
//ссылка на отправку данных о несблидении режимов или скорости
const char* host = "192.168.4.1";
//переменные для контроля задержки при получении информации о режиме
unsigned long previousMillis = 0;
const long interval = 5000;

//пины рядов кнопок
GButton first_roll_work (4);
GButton second_roll_work (2);
GButton third_roll_work (5);
GButton first_roll_relax (4);
GButton second_roll_relax (2);
GButton third_roll_relax (5);
//переменные режимов
String rezim;
int rab, otdih;

//переменные для контроля частоты и силы нажатия на педаль
int zikl_send = 0, oshib_not_click = 0, oshib_long_click = 0, oshib_not_relax = 0;
long long click_time_not = 0, click_time_long = 0, click_time = 0;

void setup() {
  Serial.begin(115200);//подключение ком порта
  //подключение к WiFi
  WiFi.begin(ssid, password);
  Serial.println("Connecting");
  //ожидание подключения
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print("connecting...");
  }
  //вывод IP адрес этой платы
  Serial.print("Connected to WiFi - IP Address: ");
  Serial.println(WiFi.localIP());

  first_roll_work.setTimeout(20000);
  second_roll_work.setTimeout(20000);
  third_roll_work.setTimeout(20000);
  first_roll_relax.setTimeout(5000);
  second_roll_relax.setTimeout(5000);
  third_roll_relax.setTimeout(5000);
}

void loop() {
  //Опросс кнопок с помощью библиотеке "GyverButton"
  first_roll_work.tick();
  second_roll_work.tick();
  third_roll_work.tick();
  first_roll_relax.tick();
  second_roll_relax.tick();
  third_roll_relax.tick();
  //создание клиента
  WiFiClient client;
  //проверка успешного подключения
  const int httpPort = 80;
  if (!client.connect(host, httpPort)) {
    Serial.println("connection failed");
    return;
  }
  //получение информации о режиме
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= interval) {
    //проверка подключения к WiFi
    if (WiFi.status() == WL_CONNECTED ) {
      rezim = httpGETRequest(serverNameStatus);
      //вывод режима
      Serial.print("Rezim:");
      Serial.println(rezim);
      previousMillis = currentMillis;
    }
    else {
      Serial.println("WiFi Disconnected");//вывод об отключении от WiFi
    }
  }
  if (rezim == "1") {//режим работы
    if (rab != 1) {//проверка: является ли режим работой
      rab = 1;
      otdih = 0;
      click_time = 0;
      oshib_not_click = 0;
      oshib_long_click = 0;
      oshib_not_relax = 0;
      click_time_not = 0;
      click_time_long = 0;
      click_time = 0;
      Serial.println("rabota");
    }
  }
  if (rezim == "2") {// режим отдыха
    if (otdih != 1) {//проверка: является ли режим отдыхом
      rab = 0;
      otdih = 1;
      click_time = 0;
      oshib_not_click = 0;
      oshib_long_click = 0;
      oshib_not_relax = 0;
      click_time_not = 0;
      click_time_long = 0;
      click_time = 0;
      Serial.println("otdih");
    }
  }
  if (rezim == "3") {//отмена(отмена всех режимов)
    rab = 0;
    otdih = 0;
    zikl_send = 0;
    oshib_not_click = 0;
    oshib_long_click = 0;
    oshib_not_relax = 0;
    click_time_not = 0;
    click_time_long = 0;
    click_time = 0;
    Serial.println("stop");
  }
  if (rab == 1 and otdih == 0) {
    //отслеживание частоты и силы нажатия на педаль
    if (not first_roll_work.isHolded() and not second_roll_work.isHolded() and not third_roll_work.isHolded()) {
      oshib_not_click ++;
      Serial.println("not work");
    }
    if (first_roll_work.isHolded() or second_roll_work.isHolded() or third_roll_work.isHolded()) {
      oshib_long_click ++;
    }
    //отправка данных о не соблюдении режима работы
    if (oshib_long_click == 5) {
      Serial.println("long_click");
      String url = "/long_click";//создание url
      //отправка данных на сервер
      client.print(String("GET ") + url + " HTTP/1.1\r\n" +
                   "Host: " + host + "\r\n" +
                   "Connection: close\r\n\r\n");
      oshib_long_click = 0;
    }
    //отправка данных о не соблюдении скоросного режима
    if (oshib_not_click == 5) {
      Serial.println("not_click");
      String url = "/not_work";//создание url
      //отправка данных на сервер
      client.print(String("GET ") + url + " HTTP/1.1\r\n" +
                   "Host: " + host + "\r\n" +
                   "Connection: close\r\n\r\n");
      oshib_not_click = 0;
    }

  }
  else if (rab == 0 and otdih == 1) {
    //отслеживание частоты нажатия на педаль
    if (first_roll_relax.isHolded() or second_roll_relax.isHolded() or third_roll_relax.isHolded()) {
      oshib_not_relax ++;
    }
    //отправление данных о не соблюдении режима отдыха
    if (oshib_not_relax == 5) {
      String url = "/not_relax";//создание url
      //отправка данных на сервер
      client.print(String("GET ") + url + " HTTP/1.1\r\n"
                   "Host: " + host + "\r\n" +
                   "Connection: close\r\n\r\n");
      oshib_not_relax = 0;
    }
  }
  //отслеживание интервала перд отключением клиента
  unsigned long timeout = millis();
  while (client.available() == 0) {
    if (millis() - timeout > 5000) {
      Serial.println(">>> Client Timeout !");
      client.stop();
      return;
    }
  }
}


//функция для получения информации о режыме
String httpGETRequest(const char* serverName) {
  WiFiClient client;
  HTTPClient http;
  http.begin(client, serverName);
  int httpResponseCode = http.GET();//запаминание http response code
  String payload = "--";
  //проверка о нелиция ощибки
  if (httpResponseCode > 0) {
    //вывод http response  code
    Serial.print("HTTP Response code: ");
    Serial.println(httpResponseCode);
    payload = http.getString();
  }
  else {
    //вывод об ошибке http response code
    Serial.print("Error code: ");
    Serial.println(httpResponseCode);
  }
  // окончание
  http.end();
  return payload;
}
