//датчики и исполительные элементы
#define trig_nobody 14
#define echo_nobody 12
#define relay_eda 7
#define relay_teplo 1
#define relay_holod 1
#define relay_voda 23
#define dadchik_voda 26
#define dadchik_temp 2
#define knopka_plus 39
#define knopka_minus 36
#define knopka_menu 13
//пременные для ультрозвукаго датчика
//переменные температуры
float needed_temp = 20;
int distance_food, distance_nobody = 10;
long duration, cm;

#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

void setup() {
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
  pinMode(trig_nobody, OUTPUT); // Определяем вывод
  pinMode(knopka_menu, INPUT);
  pinMode(knopka_plus, INPUT);
  pinMode(knopka_minus, INPUT);
  pinMode(relay_eda, OUTPUT);
  pinMode(relay_teplo, OUTPUT);
  pinMode(relay_voda, OUTPUT);

  Serial.begin(115200);
}

void loop() {
  digitalWrite(trig_nobody, LOW);
  delay(5);
  digitalWrite(trig_nobody, HIGH);
  // Установим высокий уровень сигнала
  delayMicroseconds(10);
  digitalWrite(trig_nobody, LOW);
  //  Определяем задержку сигнала
  duration = pulseIn(echo_nobody, HIGH);
  // Преобразуем время задержки в расстояние
  cm = (duration / 2) / 29.1;
  Serial.println(digitalRead(knopka_menu));
  if (digitalRead(knopka_menu) == 0) {

    if (analogRead(knopka_plus) > 500) {
      needed_temp ++;
    }
    if (analogRead(knopka_minus) > 500) {
      needed_temp --;
    }
  } else {
    Serial.println((String)analogRead(dadchik_voda) + "__" + cm);
    if (cm < distance_nobody and analogRead(dadchik_voda) < 1000) {
      digitalWrite(relay_voda, HIGH);
      Serial.println("yes");
    } else {
      digitalWrite(relay_voda, LOW);
      Serial.println("no");
    }

    if (distance_nobody - 2 > cm and cm == distance_food) {
      digitalWrite(relay_voda, HIGH);
    } else {
      digitalWrite(relay_voda, LOW);
    }
    distance_food = (duration / 2) / 29.1;
    
  }
}
